--- strace.c.orig	Tue Nov 11 16:24:23 2003
+++ strace.c	Sun Nov 28 01:33:18 2004
@@ -798,7 +798,11 @@
 	        return -1;
 	}
 	arg &= ~PF_LINGER;
+#if __FreeBSD_version >= 600007
+	if (ioctl(tcp->pfd, PIOCSFL, &arg) < 0) {
+#else
 	if (ioctl(tcp->pfd, PIOCSFL, arg) < 0) {
+#endif /* __FreeBSD_version */
 	        perror("PIOCSFL");
 	        return -1;
 	}
@@ -859,7 +863,11 @@
 #else /* FREEBSD */
 	/* set events flags. */
 	arg = S_SIG | S_SCE | S_SCX ;
+#if __FreeBSD_version >= 600007
+	if(ioctl(tcp->pfd, PIOCBIS, &arg) < 0) {
+#else
 	if(ioctl(tcp->pfd, PIOCBIS, arg) < 0) {
+#endif
 		perror("PIOCBIS");
 		return -1;
 	}
@@ -898,7 +906,7 @@
 					break;
 			}
 			/* Set it running: maybe execve will be next. */
-#ifndef FREEBSD
+#if !defined(FREEBSD) || ((defined FREEBSD) && (__FreeBSD_version >= 600007))
 			arg = 0;
 			if (IOCTL(tcp->pfd, PIOCRUN, &arg) < 0) {
 #else /* FREEBSD */
@@ -1796,7 +1804,7 @@
 			break;
 		}
 		arg = 0;
-#ifndef FREEBSD
+#if !defined(FREEBSD) || ((defined FREEBSD) && (__FreeBSD_version >= 600007))
 		if (IOCTL (tcp->pfd, PIOCRUN, &arg) < 0) {
 #else
 		if (IOCTL (tcp->pfd, PIOCRUN, 0) < 0) {

